Weather.Mode = newClass(Wdgt.Mode, {
	map: {
		// дождь == зонтик
		1:	{
			title: 'дождь',
			icon: {big: 'rain', small : 'rain'},
			background: {
				day:	['air-rain', 'rain', null, 'rain-top', 'rainclouds'],
				night:	['air', 'rain', null, 'rain-top', 'cloud']
			}
		},
		// снег == снежинка
		2:	{
			title: 'снег',
			icon: {big: 'snow', small : 'snow'},
			background: {
				day:	['air', null, 'snow', 'snow-top', 'cloud'],
				night:	['air', 'moon', null, 'snow', 'snow-top', 'cloud']
			}
		},
		// дождь, возможен град == зонтик + град
		3:	{
			title: 'дождь, возможен град',
			icon: {big: 'rain-hail', small : 'rain'},
			background: {
				day:	['air', null, 'hail', 'rain-top', 'rainclouds'],
				night:	['air', null, 'hail', 'rain-top', 'cloud']
			} 
		},
		// осадки == зонтик
		4:	{
			title: 'осадки',
			icon: {big: 'rain', small : 'rain'},
			background: {
				day:	['air-rain', 'rain', null, 'rain-top', 'rainclouds'],
				night:	['air', 'rain', null, 'rain-top', 'cloud']
			}
		},
		// облачно == тучка
		5:	{
			title: 'облачно',
			icon: {big: 'cloudiness', small : 'cloudiness'},
			background: {
				day:	['air', null, 'cloud'],
				night:	['air', null, 'cloud']
			}
		},
		// переменная облачность == тучка на солнышке
		6:	{
			title: 'переменная облачность',
			icon: {big: 'partly-cloudy', small : 'partly-cloudy'},
			background: {
				day:	['air', 'sun', null, 'cloud'],
				night:	['air', 'moon', null, 'cloud']
			}
		},
		// ясно == солнышко
		7:	{
			title: 'ясно',
			icon: {big: 'clear', small : 'clear'},
			background: {
				day:	['air', 'sun', null],
				night:	['air', 'stars' , 'moon', null]
			}
		},
		// дождь, гроза == молния на тучке + зонтик
		8:	{
			title: 'дождь, гроза',
			icon: {big: 'storm-rain', small : 'rain'},
			background: {
				day:	['air-rain', 'rain', 'flash', null, 'rain-top', 'rainclouds'],
				night:	['air', 'rain', 'flash', null, 'rain-top', 'cloud']
			}
		},
		// переменная облачность, дождь == тучка на солнышке + зонтик
		9:	{
			title: 'переменная облачность, дождь',
			icon: {big: 'partly-cloudy-rain', small : 'rain'},
			background: {
				day:	['air-rain', 'sun', 'rain', null, 'rain-top', 'rainclouds'],
				night:	['air', 'moon', 'rain', null, 'rain-top', 'cloud']
			}
		},
		// переменная облачность, дождь == тучка на солнышке + зонтик
		10:	{
			title: 'переменная облачность, дождь',
			icon: {big: 'partly-cloudy-rain', small : 'rain'},
			background: {
				day:	['air-rain', 'sun', 'rain', null, 'rain-top', 'rainclouds'],
				night:	['air', 'moon', 'rain', null, 'rain-top', 'cloud']
			}
		},
		// облачно, небольшой дождь == тучка + зонтик
		11:	{
			title: 'облачно, небольшой дождь',
			icon: {big: 'cloudiness-rain', small : 'rain'},
			background: {
				day:	['air-rain', 'rain', null, 'rainclouds'],
				night:	['air', 'rain', null, 'cloud']
			}
		},
		// переменная облачность, небольшой снег == тучка на солнышке + снежинка
		12:	{
			title: 'переменная облачность, небольшой снег',
			icon: {big: 'partly-cloudy-snow', small : 'snow'},
			background: {
				day:	['air', 'sun', 'snow', null, 'cloud'],
				night:	['air', 'moon', 'snow', null, 'cloud']
			}
		},
		// облачно, небольшой снег == тучка + снежинка
		13:	{
			title: 'облачно, небольшой снег',
			icon: {big: 'cloudiness-snow', small : 'snow'},
			background: {
				day:	['air', 'snow', null, 'cloud'],
				night:	['air', 'snow', null, 'cloud']
			}
		},
		// переменная облачность, небольшие осадки == тучка на солнышке + зонтик
		14:	{
			title: 'переменная облачность, небольшие осадки',
			icon: {big: 'partly-cloudy-rain', small : 'rain'},
			background: {
				day:	['air-rain', 'sun', 'rain', null, 'rainclouds'],
				night:	['air', 'moon', 'rain', null, 'cloud']
			}
		},
		// облачно, небольшие осадки == тучка + зонтик
		15:	{
			title: 'облачно, небольшие осадки',
			icon: {big: 'cloudiness-rain', small : 'rain'},
			background: {
				day:	['air-rain', 'rain', null, 'rainclouds'],
				night:	['air', 'rain', null, 'cloud']
			}
		},
		// облачно, без существенных осадков == тучка
		16:	{
			title: 'облачно, без существенных осадков',
			icon: {big: 'cloudiness', small : 'cloudiness'},
			background: {
				day:	['air', null, 'cloud'],
				night:	['air', null, 'cloud']
			}
		},
		// метель == вертикальный снег
		17:	{
			title: 'метель',
			icon: {big: 'snow', small : 'snow'},
			background: {
				day:	['air', null, 'snow', 'snow-top', 'cloud'],
				night:	['air', null, 'snow', 'snow-top', 'cloud']
			}
		},
		// туман == противотуманные фары
		18:	{
			title: 'туман',
			icon: {big: 'fog', small : 'fog'},
			background: {
				day:	['fog', null, 'fog-top'],
				night:	['air', 'fog', null, 'fog-top']
			}
		}
	},
	constructor: function(owner) {
		this.constructor.prototype.constructor.call(this);
		var context = this;
		this.owner = owner;
		this.current = {};
		this.platform = Wdgt.platform.name;

		Wdgt.preferences.mode('aircraft', 'instance-collection', 'balloon'); // {balloon, dirigible}
		Wdgt.preferences.mode('forecast', 'instance-collection', 'on'); // {on, off}
		
		this.mode('mode', {transition: {'default': 'ToFront', 'preferences': 'ToBack'}, event: this.redraw});
		this.mode('aircraft', {store: 'aircraft'});
		this.mode('forecast', {store: 'forecast', event: this.redraw});
		this.mode('time', {});
		this.mode('size', {event: this.redraw});
		
		this.set('time', 'day');
		this.set('aircraft', Wdgt.preferences.get('aircraft'));
		this.onCheckState();
		this.set('forecast', Wdgt.preferences.get('forecast'));
		this.set('mode', 'normal');
		
		// events
		if (this.platform == 'sidebar') {	
			function onCheckState() {context.onCheckState.call(context);}
			System.Gadget.onDock = onCheckState;
			System.Gadget.onUndock = onCheckState;
		}
		if (this.platform == 'sidebar')
			y5.Events.observe('click', this.toggleForecast, y5.Dom.$('panel-button-forecast'), true, this);
		y5.Events.observe(this.platform == 'sidebar' ? 'dblclick' : 'click', this.toggleForecast, y5.Dom.$('normal'), true, this);


	},
	toggleForecast: function(e) {
		this.set('forecast', this.get('forecast') == 'on' ? 'off' : 'on');
	},
	onCheckState: function() {
		this.set('size', ((this.platform == 'sidebar') && Wdgt.utils.isDocked()) ? 'small' : 'big')
	},
	redraw: function(space, value) {
		var mode = this.get('mode');
		var size = this.get('size');
		var forecast = this.get('forecast');
		
		switch(mode) {
			case 'normal':
				this.show();
				var sizes = {
					'big': {
						'on': {width: 250, height: 320},
						'off': {width: 250, height: 250}
					},
					'small': {
						'on': {width: 130, height: 235},
						'off': {width: 130, height: 150}
					}
				}
				Wdgt.view.setSize(sizes[size][forecast].width, sizes[size][forecast].height);			
				Wdgt.view.setBackground(this.background(size));
			break;
			case 'preferences':
				Wdgt.view.setSize(300, 290);
				Wdgt.view.setBackground([{url: 'kernel/images/preferences' + (Wdgt.platform.os == 'linux' ? '-opera' : '') + '.png', left: 0, top: 0}]);
			break;
		}
	},
	width: function(text, font) {
		var node = y5.Dom.$('width-test');
		if (!node) {
			node = document.createElement('div');
			with(node.style) {
				//display = 'inline';
				styleFloat = 'left';
				border = '1px solid red';
				margin = '0';
				padding = '0';
				visibility = 'hidden';
			}
			document.body.appendChild(node);
		}
		node.style.fontFamily = font.family;
		node.style.fontSize = font.size + 'px';
		node.innerHTML = text;
		return node.clientWidth + 6;
	},
	background: function(size) {
		var sky = '';
		var time = 'day';
		var number = '7';
		var forecast = this.owner.data.current.forecast;
		if(forecast)
			number = forecast.fact.image;
		if(number.substr(0,1) == 'n') {
			number = number.substr(1);
			time = 'night';
		}
		number = parseInt(number);
		
		this.set('time', time);

		var sky = this.map[number]['background'][time];
		
		var result = [];

		var position = {
			'small': {x: 0, y: 117},
			'big': {x: 15, y: 202}
		};

		//if (this.get('forecast') == 'on')
		//	result.push({url: 'kernel/images/table/' + size + '/' + time + '.png', left: position[size].x, top: position[size].y});

		for (var i = 0; i < sky.length; i ++)
			if (sky[i])
				result.push({url: 'kernel/images/sky/' + size + '/' + time + '/' + sky[i] + '.png', left: 0, top: 0});
			else {
				if (this.get('forecast') == 'on')
					result.push({url: 'kernel/images/table/' + size + '/' + time + '.png', left: position[size].x, top: position[size].y});
				else
					if (forecast)
						result.push({url: 'kernel/images/city/' + (this.platform == 'sidebar' ? 'sidebar' : 'other') + '/' + time + '.png', left: (size == 'small' ? 0 : 60), top: (size == 'small' ? 117 : 207)});
				
				result.push({url: 'kernel/images/aircraft/' + size + '/' + this.get('aircraft') + '/' + time + '.png', left: 0, top: 0});
			}
		
		return result;	
	},
	show: function() {
		var size = this.get('size');		
		var forecast = this.owner.data.current.forecast;
		if (forecast) {
			var table = document.createElement('table');
			var tbody = document.createElement('tbody');
			table.appendChild(tbody);
			var tr_date = document.createElement('tr');
			var tr_image = document.createElement('tr');
			var tr_day = document.createElement('tr');
			var tr_night = document.createElement('tr');
			
			tbody.appendChild(tr_date);
			tbody.appendChild(tr_image);
			tbody.appendChild(tr_day);
			tbody.appendChild(tr_night);
						
			var cols = (size == 'big') ? 5 : 4;
			for(var i = 0; i < cols; i++) {
				var day = forecast.forecast[i];
				var td_date = document.createElement('td');
				var td_image = document.createElement('td');
				var td_day = document.createElement('td');
				var td_night = document.createElement('td');
				
				td_date.className = 'date';
				td_image.className = 'image';
				td_day.className = 'day';
				td_night.className = 'night';
				td_image.style.backgroundImage = 'url(kernel/images/weather/' + this.map[day.day.image.replace('n', '')].icon[size] + '.png)';
				///td_image.setAttribute('title', this.map[day.day.image].title);
				
				td_date.innerHTML = '<span class="one">' + day.date.day + '</span>, <span class="two">' + day.date.date + '</span>';
				td_day.innerHTML = this.celsius(day.day.temperature);
				td_night.innerHTML = this.celsius(day.night.temperature);
				
				var tooltip = {day: this.tooltip_forecast(day, 'day'), night: this.tooltip_forecast(day, 'night')};
				td_date.setAttribute('title', tooltip.day);
				td_image.setAttribute('title', tooltip.day);
				td_day.setAttribute('title', tooltip.day);
				td_night.setAttribute('title', tooltip.night);
				
				y5.Classes.assign(td_date, 'weekend', day.date.day == 'сб' || day.date.day == 'вс');
				
				tr_date.appendChild(td_date);
				tr_image.appendChild(td_image);
				tr_day.appendChild(td_day);
				tr_night.appendChild(td_night);
			}
			
			var node_city = document.createElement('div');
			var node_city_span = document.createElement('span');
			node_city.className = 'city';
			node_city_span.innerHTML = this.owner.data.getCity();
			node_city.appendChild(node_city_span);
			y5.Dom.$('city-value').innerHTML = this.owner.data.getCity();
			node_city_span.onclick = function() {};
			y5.Events.observe('click', this.owner.openYandexWeatherWebPage, node_city_span, true, this.owner);

	
			var node_date = document.createElement('div');
			node_date.className = 'date';
			node_date.innerHTML = forecast.fact.date.date + ', ' + forecast.fact.date.day;
			
			var node_forecast = y5.Dom.$('forecast');
			node_forecast.innerHTML = '';
			node_forecast.appendChild(node_city);
			node_forecast.appendChild(node_date);
			node_forecast.appendChild(table);
			
			var node_fact = y5.Dom.$('fact-value');
			
			node_fact.innerHTML = (parseInt(forecast.fact.temperature) == 0 ? '&nbsp;' : '') +  this.celsius(forecast.fact.temperature) + '°';			
			
			var tooltip = this.tooltip_fact(forecast);
			var city = this.owner.data.getCity();
			y5.Dom.$('forecast').setAttribute('title', tooltip);
			y5.Dom.$('city-value').setAttribute('title', (city.length > 14 ? city : "Посмотреть погоду на Яндексе"));
			node_city_span.setAttribute('title', y5.Dom.$('city-value').getAttribute('title'));
		} else {
			y5.Dom.$('forecast').innerHTML = '';
			y5.Dom.$('city-value').innerHTML = '';
			y5.Dom.$('fact-value').innerHTML = '';
			y5.Dom.$('forecast').setAttribute('title', '');
			y5.Dom.$('city-value').setAttribute('title', 'Посмотреть погоду на Яндексе');	
		}
		if (this.platform == 'opera') {
			y5.Dom.$('normal').style.display = 'none';
			setTimeout(function () {y5.Dom.$('normal').style.display = '';}, 1);
		}
	},
	direction: function(s) {
		s = s.replace('n', 'С');
		s = s.replace('s', 'Ю');
		s = s.replace('w', 'З');
		s = s.replace('e', 'В');
		return s;
	},
	tooltip_forecast: function(day, time) {
		var text = y5.Dates.toFormat(new Date(day.date.object), '%e %B %Y года') + '\n' + (time == 'day' ? 'Днем' : 'Ночью') + ':\n';
		with(day[time]) {
			text += this.celsius(temperature) + '°C, ' + type + '\n' +
			'Ветер: ' + this.direction(wind_direction) + ', ' + wind_speed + ' м/с\n' +
			'Давление: ' + pressure + ' мм.рт.ст.\n' + 
			'Влажность: ' + humidity + ' %';
		}
		with (day) {
			text +=	'\n' + (time == 'day' ?
				'Солнце: восход: ' + sunrise + ', закат: ' + sunset
				:
				'Луна: восход: ' + moonrise + ', заход: ' + moonset
			);
		}
		return text;
	},
	tooltip_fact: function(forecast) {
		var fact = forecast.fact;
		with(forecast.fact) {
			return  '' + this.owner.data.getCity() + '\n' +
				y5.Dates.toFormat(new Date(date.object), '%e %B %Y года') + '\n' +
				this.celsius(temperature) + '°C, ' + type + '\n' +
				'Ветер: ' + this.direction(wind_direction) + ', ' + wind_speed + ' м/с\n' +
				'Давление: ' + pressure + ' мм.рт.ст.\n' + 
				'Влажность: ' + humidity + ' %' + 
				(fact.alert ? '\n' + fact.alert : '');
		}
	},
	celsius: function(x) {
		if(typeof x == 'string')
			x = x.replace(/−/gm, '-');
		x = parseInt(x);
		return (x == 0 ? '0' : (x > 0 ? '+' + x : '–' /* <- unicode symbol! */ + (-x)));
	}
});