Weather = newClass(null, {
	name: "widget.weather",
	title: 'Яндекс.Погода',
	version: 1.010011,
	clid: {status: 49174, morda: 49175},
	require: ['Dates'],
	constructor: function(menu, behaviour) {
		var context = this;
		this.data = new Weather.Data(this);
		this.mode = new Weather.Mode(this);
		this.preferences = new Weather.Preferences(this);
		
		y5.Classes.add(document.body, Wdgt.platform.os);
		y5.Classes.assign(document.body, 'standalone-application', /Version\/((10.[2-9]\d)|(1[1-9].\d\d)|([2-9]\d.\d\d))/.test(navigator.userAgent));
		this.platform = Wdgt.platform.name;
		
		if(this.platform == 'sidebar') {
			y5.Dom.$('city-value').onclick = function() {};
			y5.Dom.$('fact-value').onclick = function() {};
			y5.Dom.$('link-to-yandex').onclick = function() {};
		} else {
			y5.Events.observe('click', this.doUpdate, y5.Dom.$('preferences-update-link'), true, this);
			//y5.Events.observe('click', this.doUpdate, y5.Dom.$('update'), true, this);
		}

		if (this.platform == 'dashboard') {
		}

		if (this.platform == 'opera') {
			y5.Events.observe('click', this.close, y5.Dom.$('panel-button-close'), true, this);
		}

		y5.Events.observe('click', this.openYandexWeatherWebPage, y5.Dom.$('city-value'), true, this);
		y5.Events.observe('click', this.openYandexWeatherWebPage, y5.Dom.$('fact-value'), true, this);
		y5.Events.observe('click', this.openYandexWebPage, y5.Dom.$('link-to-yandex'), true, this);

		new y5.Observer('update', this.onUpdate, this, true, this);
	},
	close: function(e) {
		if (e)
			e.stopPropagation();
		Wdgt.utils.close();
	},
	openYandexWeatherWebPage: function(e) {
		e.stopPropagation();
		Wdgt.utils.openURL('http://weather.yandex.ru/?city=' + this.data.getWeatherId() + '&yasoft=' + this.name);
	},
	openYandexWebPage: function(e) {
		e.stopPropagation();
		Wdgt.utils.openURL(Wdgt.address('morda'));
	},
	onUpdate: function() {
		y5.Classes.assign(document.body, 'update', Wdgt.update.status.update);
	},
	doUpdate: function(e) {
		e.stopPropagation();
		e.preventDefault();
		Wdgt.utils.openURL(Wdgt.update.status.url);
	}
});

Wdgt.Widget = Weather;